---
references:
- id: AbbeelLearning2006
  accessed:
    - year: 2014
      month: 8
      day: 20
  author:
    - family: Abbeel
      given: Pieter
    - family: Koller
      given: Daphne
    - family: Ng
      given: Andrew Y.
  citation-key: AbbeelLearning2006
  container-title: Journal of Machine Learning Research
  ISSN: 1532-4435
  issued:
    - year: 2006
      month: 12
  page: 1743–1788
  title: Learning Factor Graphs in Polynomial Time and Sample Complexity
  type: article-journal
  URL: http://machinelearning.wustl.edu/mlpapers/paper_files/AbbeelKN06.pdf
  volume: '7'

- id: AkbayrakExtended2021
  accessed:
    - year: 2024
      month: 2
      day: 23
  author:
    - family: Akbayrak
      given: Semih
    - family: Bocharov
      given: Ivan
    - family: Vries
      given: Bert
      non-dropping-particle: de
  citation-key: AkbayrakExtended2021
  container-title: Entropy
  DOI: 10.3390/e23070815
  ISSN: 1099-4300
  issue: '7'
  issued:
    - year: 2021
      month: 7
  language: en
  number: '7'
  page: '815'
  publisher: Multidisciplinary Digital Publishing Institute
  title: >-
    Extended Variational Message Passing for Automated Approximate Bayesian
    Inference
  type: article-journal
  URL: https://www.mdpi.com/1099-4300/23/7/815
  volume: '23'

- id: BicksonGaussian2009
  accessed:
    - year: 2022
      month: 2
      day: 7
  author:
    - family: Bickson
      given: Danny
  citation-key: BicksonGaussian2009
  genre: PhD
  issued:
    - year: 2009
      month: 7
      day: 12
  language: en
  title: 'Gaussian Belief Propagation: Theory and Application'
  type: thesis
  URL: http://arxiv.org/abs/0811.2518

- id: CoxFactor2019
  accessed:
    - year: 2019
      month: 12
      day: 10
  author:
    - family: Cox
      given: Marco
    - family: Laar
      given: Thijs
      non-dropping-particle: van de
    - family: Vries
      given: Bert
      non-dropping-particle: de
  citation-key: CoxFactor2019
  container-title: International Journal of Approximate Reasoning
  container-title-short: International Journal of Approximate Reasoning
  DOI: 10.1016/j.ijar.2018.11.002
  ISSN: 0888613X
  issued:
    - year: 2019
      month: 1
  page: 185-204
  title: >-
    A Factor Graph Approach to Automated Design of Bayesian Signal Processing
    Algorithms
  type: article-journal
  URL: http://arxiv.org/abs/1811.03407
  volume: '104'

- id: CoxRobust2018
  accessed:
    - year: 2022
      month: 5
      day: 3
  author:
    - family: Cox
      given: Marco
    - family: De Vries
      given: Bert
  citation-key: CoxRobust2018
  container-title: 2018 26th European Signal Processing Conference (EUSIPCO)
  DOI: 10.23919/EUSIPCO.2018.8553490
  event-place: Rome
  event-title: 2018 26th European Signal Processing Conference (EUSIPCO)
  ISBN: 978-90-827970-1-5
  issued:
    - year: 2018
      month: 9
  language: en
  page: 2583-2587
  publisher: IEEE
  publisher-place: Rome
  title: >-
    Robust Expectation Propagation in Factor Graphs Involving Both Continuous
    and Binary Variables
  type: paper-conference
  URL: >-
    https://biaslab.github.io/pdf/eusipco2018/cox_robust_expectation_propagation.pdf

- id: DauwelsVariational2007
  accessed:
    - year: 2022
      month: 2
      day: 11
  author:
    - family: Dauwels
      given: Justin
  citation-key: DauwelsVariational2007
  container-title: 2007 IEEE International Symposium on Information Theory
  DOI: 10.1109/ISIT.2007.4557602
  event-place: Nice
  event-title: 2007 IEEE International Symposium on Information Theory
  ISBN: 978-1-4244-1397-3
  issued:
    - year: 2007
      month: 6
  language: en
  page: 2546-2550
  publisher: IEEE
  publisher-place: Nice
  title: On Variational Message Passing on Factor Graphs
  type: paper-conference

- id: DellaertFactor2017
  accessed:
    - year: 2022
      month: 2
      day: 7
  author:
    - family: Dellaert
      given: Frank
    - family: Kaess
      given: Michael
  citation-key: DellaertFactor2017
  container-title: Foundations and Trends® in Robotics
  container-title-short: FNT in Robotics
  DOI: 10.1561/2300000043
  ISSN: 1935-8253, 1935-8261
  issue: 1-2
  issued:
    - year: 2017
      month: 8
      day: 14
  language: English
  page: 1-139
  publisher: Now Publishers, Inc.
  title: Factor Graphs for Robot Perception
  type: article-journal
  URL: >-
    https://web.archive.org/web/20190603175911id_/http://www.cs.cmu.edu/~kaess/pub/Dellaert17fnt.pdf
  volume: '6'

- id: deVriesFactor2017
  accessed:
    - year: 2022
      month: 2
      day: 2
  author:
    - family: Vries
      given: Bert
      non-dropping-particle: de
    - family: Friston
      given: Karl J.
  citation-key: deVriesFactor2017
  container-title: Frontiers in Computational Neuroscience
  ISSN: 1662-5188
  issued:
    - year: 2017
  title: A Factor Graph Description of Deep Temporal Active Inference
  type: article-journal
  URL: https://www.frontiersin.org/article/10.3389/fncom.2017.00095
  volume: '11'

- id: ElKurdiParallel2014
  author:
    - family: El-Kurdi
      given: Yousef Malek
  citation-key: ElKurdiParallel2014
  genre: PhD Thesis
  issued:
    - year: 2014
  publisher: McGill University
  title: >-
    Parallel Finite Element Processing Using Gaussian Belief Propagation
    Inference on Probabilistic Graphical Models
  type: thesis

- id: ForneyCodes2001
  author:
    - family: Forney
      given: G.D.
  citation-key: ForneyCodes2001
  container-title: IEEE Transactions on Information Theory
  DOI: 10.1109/18.910573
  ISSN: 1557-9654
  issue: '2'
  issued:
    - year: 2001
      month: 2
  page: 520-548
  title: 'Codes on graphs: normal realizations'
  type: article-journal
  volume: '47'

- id: FreyExtending2003
  accessed:
    - year: 2014
      month: 8
      day: 26
  author:
    - family: Frey
      given: Brendan J.
  citation-key: FreyExtending2003
  collection-title: UAI'03
  container-title: >-
    Proceedings of the Nineteenth Conference on Uncertainty in Artificial
    Intelligence
  event-place: San Francisco, CA, USA
  ISBN: 0-12-705664-5
  issued:
    - year: 2003
  page: 257–264
  publisher: Morgan Kaufmann Publishers Inc.
  publisher-place: San Francisco, CA, USA
  title: >-
    Extending factor graphs so as to unify directed and undirected graphical
    models
  type: paper-conference
  URL: http://arxiv.org/abs/1212.2486

- id: FreyFactor1997
  author:
    - family: Frey
      given: Brendan J.
    - family: Kschischang
      given: Frank R.
    - family: Loeliger
      given: Hans-Andrea
    - family: Wiberg
      given: Niclas
  citation-key: FreyFactor1997
  container-title: >-
    Proceedings of the Annual Allerton Conference on Communication Control and
    Computing
  issued:
    - year: 1997
  page: 666–680
  publisher: Citeseer
  title: Factor graphs and algorithms
  type: paper-conference
  volume: '35'

- id: GrimmettTheorem1973
  accessed:
    - year: 2023
      month: 2
      day: 10
  author:
    - family: Grimmett
      given: G. R.
  citation-key: GrimmettTheorem1973
  container-title: Bulletin of the London Mathematical Society
  DOI: 10.1112/blms/5.1.81
  ISSN: 1469-2120
  issue: '1'
  issued:
    - year: 1973
  language: en
  page: 81-84
  title: A Theorem about Random Fields
  type: article-journal
  volume: '5'

- id: HasencleverDistributed2017
  author:
    - family: Hasenclever
      given: Leonard
    - family: Webb
      given: Stefan
    - family: Lienart
      given: Thibaut
    - family: Vollmer
      given: Sebastian
    - family: Lakshminarayanan
      given: Balaji
    - family: Blundell
      given: Charles
    - family: Teh
      given: Yee Whye
  citation-key: HasencleverDistributed2017
  container-title: The Journal of Machine Learning Research
  DOI: 10.48550/arXiv.1512.09327
  issued:
    - year: 2017
      month: 1
      day: 1
  page: 3744–3780
  title: >-
    Distributed Bayesian learning with stochastic natural gradient expectation
    propagation and the posterior server
  type: paper-conference
  URL: http://arxiv.org/abs/1512.09327
  volume: '18'

- id: KorlFactor2005
  accessed:
    - year: 2022
      month: 2
      day: 2
  author:
    - family: Korl
      given: Sascha
  citation-key: KorlFactor2005
  DOI: 10.3929/ethz-a-005064226
  event-place: Konstanz
  ISBN: '9783866280328'
  issued:
    - year: 2005
  language: en
  medium: application/pdf
  page: 187 S.
  publisher: ETH Zurich
  publisher-place: Konstanz
  title: >-
    A factor graph approach to signal modelling, system identification and
    filtering
  type: thesis
  URL: http://hdl.handle.net/20.500.11850/82737

- id: KschischangFactor2001
  author:
    - family: Kschischang
      given: Frank R
    - family: Frey
      given: Brendan J
    - family: Loeliger
      given: Hans-Andrea
  citation-key: KschischangFactor2001
  container-title: IEEE Transactions on Information Theory
  DOI: 10.1109/18.910572
  ISSN: 0018-9448
  issue: '2'
  issued:
    - year: 2001
      month: 2
  page: 498-519
  title: Factor graphs and the sum-product algorithm
  type: article-journal
  volume: '47'

- id: LoeligerFactor2007
  author:
    - family: Loeliger
      given: Hans-Andrea
    - family: Dauwels
      given: Justin
    - family: Hu
      given: Junli
    - family: Korl
      given: Sascha
    - family: Ping
      given: Li
    - family: Kschischang
      given: Frank R.
  citation-key: LoeligerFactor2007
  container-title: Proceedings of the IEEE
  DOI: 10.1109/JPROC.2007.896497
  ISSN: 1558-2256
  issue: '6'
  issued:
    - year: 2007
      month: 6
  page: 1295-1322
  title: The Factor Graph Approach to Model-Based Signal Processing
  type: article-journal
  volume: '95'

- id: LoeligerIntroduction2004
  author:
    - family: Loeliger
      given: H.-A.
  citation-key: LoeligerIntroduction2004
  container-title: IEEE Signal Processing Magazine
  DOI: 10.1109/MSP.2004.1267047
  ISSN: 1053-5888
  issue: '1'
  issued:
    - year: 2004
      month: 1
  page: 28-41
  title: An introduction to factor graphs
  type: article-journal
  URL: http://www.robots.ox.ac.uk/~parg/mlrg/papers/factorgraphs.pdf
  volume: '21'

- id: MaIncorporating2019
  accessed:
    - year: 2024
      month: 1
      day: 30
  author:
    - family: Ma
      given: Tianle
    - family: Zhang
      given: Aidong
  citation-key: MaIncorporating2019
  DOI: 10.48550/arXiv.1906.00537
  issued:
    - year: 2019
      month: 6
      day: 2
  number: arXiv:1906.00537
  publisher: arXiv
  title: >-
    Incorporating Biological Knowledge with Factor Graph Neural Network for
    Interpretable Deep Learning
  type: article
  URL: http://arxiv.org/abs/1906.00537

- id: MaoConvolutional2004
  accessed:
    - year: 2014
      month: 8
      day: 26
  author:
    - family: Mao
      given: Yongyi
    - family: Kschischang
      given: Frank R.
    - family: Frey
      given: Brendan J.
  citation-key: MaoConvolutional2004
  collection-title: UAI '04
  container-title: Proceedings of the 20th Conference on Uncertainty in Artificial Intelligence
  event-place: Arlington, Virginia, United States
  ISBN: 0-9749039-0-6
  issued:
    - year: 2004
  page: 374–381
  publisher: AUAI Press
  publisher-place: Arlington, Virginia, United States
  title: Convolutional Factor Graphs As Probabilistic Models
  type: paper-conference
  URL: http://arxiv.org/abs/1207.4136

- id: MaoFactor2005
  author:
    - family: Mao
      given: Yongyi
    - family: Kschischang
      given: F.R.
  citation-key: MaoFactor2005
  container-title: IEEE Transactions on Information Theory
  DOI: 10.1109/TIT.2005.846404
  ISSN: 1557-9654
  issue: '5'
  issued:
    - year: 2005
      month: 5
  page: 1635-1649
  title: On factor graphs and the Fourier transform
  type: article-journal
  URL: https://www.site.uottawa.ca/~yymao/research/FGFT.pdf
  volume: '51'

- id: MinkaDivergence2005
  accessed:
    - year: 2015
      month: 2
      day: 7
  author:
    - family: Minka
      given: Tom P
  citation-key: MinkaDivergence2005
  issued:
    - year: 2005
  publisher: Technical report, Microsoft Research
  title: Divergence measures and message passing
  type: report
  URL: >-
    http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.314.3445&rep=rep1&type=pdf

- id: ObermeyerTensor2019
  accessed:
    - year: 2024
      month: 2
      day: 21
  author:
    - family: Obermeyer
      given: Fritz
    - family: Bingham
      given: Eli
    - family: Jankowiak
      given: Martin
    - family: Chiu
      given: Justin
    - family: Pradhan
      given: Neeraj
    - family: Rush
      given: Alexander
    - family: Goodman
      given: Noah
  citation-key: ObermeyerTensor2019
  DOI: 10.48550/arXiv.1902.03210
  issued:
    - year: 2019
      month: 5
      day: 16
  number: arXiv:1902.03210
  publisher: arXiv
  title: Tensor Variable Elimination for Plated Factor Graphs
  type: article
  URL: http://arxiv.org/abs/1902.03210

- id: RellerStatespace2013
  accessed:
    - year: 2022
      month: 2
      day: 2
  author:
    - family: Reller
      given: Christoph
  citation-key: RellerStatespace2013
  contributor:
    - family: Loeliger
      given: Hans-Andrea
    - family: Dauwels
      given: Justin
  DOI: 10.3929/ETHZ-A-009752758
  event-place: Konstanz
  ISBN: '9783866284470'
  issued:
    - year: 2013
  language: en
  medium: application/pdf
  page: 1 Band
  publisher: ETH Zurich
  publisher-place: Konstanz
  title: >-
    State-space methods in statistical signal processing: New ideas and
    applications
  type: thesis
  URL: http://reller.nightcolours.ch/web/_static/publ/RellerThesis.pdf

- id: SatorrasNeural2021
  accessed:
    - year: 2023
      month: 6
      day: 27
  author:
    - family: Satorras
      given: Victor Garcia
    - family: Welling
      given: Max
  citation-key: SatorrasNeural2021
  DOI: 10.48550/arXiv.2003.01998
  event-title: AISTATS
  issued:
    - year: 2021
      month: 3
      day: 16
  publisher: arXiv
  title: Neural Enhanced Belief Propagation on Factor Graphs
  type: paper-conference
  URL: http://arxiv.org/abs/2003.01998

- id: ShermanMarkov1973
  accessed:
    - year: 2023
      month: 2
      day: 10
  author:
    - family: Sherman
      given: S.
  citation-key: ShermanMarkov1973
  container-title: Israel Journal of Mathematics
  container-title-short: Israel J. Math.
  DOI: 10.1007/BF02761538
  ISSN: 1565-8511
  issue: '1'
  issued:
    - year: 1973
      month: 3
      day: 1
  language: en
  page: 92-103
  title: Markov random fields and Gibbs random fields
  type: article-journal
  volume: '14'

- id: vandeLaarForneyLab2018
  author:
    - family: Laar
      given: Thijs
      non-dropping-particle: van de
    - family: Cox
      given: Marco
    - family: Senoz
      given: Ismail
    - family: Bocharov
      given: Ivan
    - family: Vries
      given: Bert
      non-dropping-particle: de
  citation-key: vandeLaarForneyLab2018
  container-title: Conference on Complex Systems
  issued:
    - year: 2018
  language: en
  page: '3'
  title: >-
    ForneyLab: A Toolbox for Biologically Plausible Free Energy Minimization in
    Dynamic Neural Models
  type: paper-conference
  URL: http://ccs2018.web.auth.gr/

- id: VehtariExpectation2019
  accessed:
    - year: 2022
      month: 2
      day: 11
  author:
    - family: Vehtari
      given: Aki
    - family: Gelman
      given: Andrew
    - family: Sivula
      given: Tuomas
    - family: Jylänki
      given: Pasi
    - family: Tran
      given: Dustin
    - family: Sahai
      given: Swupnil
    - family: Blomstedt
      given: Paul
    - family: Cunningham
      given: John P.
    - family: Schiminovich
      given: David
    - family: Robert
      given: Christian
  citation-key: VehtariExpectation2019
  container-title: arXiv:1412.4869 [stat]
  issued:
    - year: 2019
      month: 11
      day: 30
  title: >-
    Expectation propagation as a way of life: A framework for Bayesian inference
    on partitioned data
  type: article-journal
  URL: http://arxiv.org/abs/1412.4869

- id: WiegerinckFractional2002
  accessed:
    - year: 2024
      month: 2
      day: 29
  author:
    - family: Wiegerinck
      given: Wim
    - family: Heskes
      given: Tom
  citation-key: WiegerinckFractional2002
  container-title: Advances in Neural Information Processing Systems
  event-place: Cambridge, MA, USA
  issued:
    - year: 2002
  publisher: MIT Press
  publisher-place: Cambridge, MA, USA
  title: Fractional Belief Propagation
  type: paper-conference
  URL: >-
    https://proceedings.neurips.cc/paper_files/paper/2002/hash/35936504a37d53e03abdfbc7318d9ec7-Abstract.html
  volume: '15'

- id: XuDistributed2014
  accessed:
    - year: 2023
      month: 3
      day: 26
  author:
    - family: Xu
      given: Minjie
    - family: Lakshminarayanan
      given: Balaji
    - family: Teh
      given: Yee Whye
    - family: Zhu
      given: Jun
    - family: Zhang
      given: Bo
  citation-key: XuDistributed2014
  collection-title: NIPS'14
  container-title: >-
    Proceedings of the 27th International Conference on Neural Information
    Processing Systems - Volume 2
  event-place: Cambridge, MA, USA
  issued:
    - year: 2014
      month: 12
      day: 8
  page: 3356–3364
  publisher: MIT Press
  publisher-place: Cambridge, MA, USA
  title: Distributed Bayesian posterior sampling via moment sharing
  type: paper-conference
  URL: >-
    https://proceedings.neurips.cc/paper/2014/hash/a941493eeea57ede8214fd77d41806bc-Abstract.html

- id: ZhangFactor2020
  accessed:
    - year: 2024
      month: 1
      day: 30
  author:
    - family: Zhang
      given: Zhen
    - family: Wu
      given: Fan
    - family: Lee
      given: Wee Sun
  citation-key: ZhangFactor2020
  container-title: Advances in Neural Information Processing Systems
  issued:
    - year: 2020
  page: 8577–8587
  publisher: Curran Associates, Inc.
  title: Factor Graph Neural Networks
  type: paper-conference
  URL: >-
    https://proceedings.neurips.cc/paper/2020/hash/61c66a2f4e6e10dc9c16ddf9d19745d6-Abstract.html
  volume: '33'
...
